﻿package ru.k0t0vich.fluent.conditions 
{
	import flash.utils.getQualifiedClassName;
	/**
	 * Класс условия.
	 * TODO: сделать энумератор условий
	 * @author k0t0vich
	 */
	public class Condition
	{
		public static var EQ:String = "==";
		public static var NE:String = "!=";
		public static var GT:String = ">";
		public static var LT:String = "<";
		public static var GE:String = ">=";
		public static var LE:String = "<=";
		
		private var field:String;
		private var condition:String;
		private var value:*;
		
		/**
		 * Ф-ция вида:
		 * func(fieldValue:*):Boolean           
		 */
		private var valueFunction:Function 
		
		public function Condition($field:String,$condition:String,$value:*) 
		{
			
			field = $field;
			value = $value;
			condition = $condition;
			switch($condition)
			{
				case Condition.EQ:
					valueFunction = valueEQ;
				break;
				case Condition.NE:
					valueFunction = valueNE;
				break;
				case Condition.GT:
					valueFunction = valueGT;
				break;
				case Condition.LT:
					valueFunction = valueLT;
				break;
				case Condition.GE:
					valueFunction = valueGE;
				break;
				case Condition.LE:
					valueFunction = valueLE;
				break;
				default:
					throw new Error("'" + condition + "'" + " is illegal condition");
				break;
			}
		}
		
		/**
		 * Вычислить выражение для юнита
		 * @param	unit
		 * @return
		 */
		public function valueCondition(unit:*):Boolean
		{
			try {
				var fieldValue:*= unit[field];
				return valueFunction(fieldValue);
			}
			catch (e:Error)
			{
				throw new Error("'"+field+"'"+ " is not member of "+ getQualifiedClassName(unit)+"! Standart error: "+e);
			}
			return false;
		}
		
		private function valueEQ(fieldValue:*):Boolean
		{
				return (fieldValue == value);
		}
		
		private function valueNE(fieldValue:*):Boolean
		{
				return (fieldValue != value);
		}
		
		private function valueGT(fieldValue:*):Boolean
		{
				return (fieldValue > value);
		}
		
		private function valueLT(fieldValue:*):Boolean
		{
				return (fieldValue < value);
		}
		
		private function valueGE(fieldValue:*):Boolean
		{
				return (fieldValue >= value);	
		}
		
		private function valueLE(fieldValue:*):Boolean
		{
				return (fieldValue <= value);
		}
		
		public function toString():String
		{
			return "[Condition : "+field+condition+value+ "]"
		}
	}

}