﻿package ru.k0t0vich.fluent.parsers 
{


	import ru.k0t0vich.fluent.FluentList;
	/**
	 * Парсит строку вида:
	 
		 where z < -80; 
		 or; 
		 sortOn z numeric;
		 call doShoot 1 10;
	 
	 * @author k0t0vich
	 */
	public class FluentStringParser
	{
		private static const DOUBLE_SPACE_RX:RegExp = /\s+/g;
		private static const ENTER_SPACE_RX :RegExp = /^\s+/g;
		private static const OUTER_SPACE_RX :RegExp = /\s^./g;
	//	private static const COMMAND_RX :RegExp = /([\w\.\-]+|[><!=+*]+)/g;
		private static const COMMAND_RX :RegExp = /([\w\.\-]+|[><!=]+)/g;
		private static const OR_RX :RegExp = /([or]-;/g;
		//private static const DELEMITER_RX :RegExp = /;|and|\)|\r|\n/g;
		private static const DELEMITER_RX :RegExp = /;/g;
		
		public static function parse(fluentList:FluentList, str:String):FluentList
		{
			
			var retFluentList:FluentList = fluentList;
			var commandArray:Array = str.split(DELEMITER_RX);
			trace("commandArray : " + commandArray);
			
			var len:int = commandArray.length;
			for (var i:int = 0; i < len; i++) 
			{
				var commandString:String = commandArray[i];
				retFluentList = CommandParser.parse(retFluentList,toCommand(commandString));
			}
			
			return retFluentList;
		}
		
		static private function toCommand(str:String):Array
		{			
			var arr:Array = str.match(COMMAND_RX);
			return arr;
		}
		
		
		
	}

}